/*
 * forkt.c
 *
 * Demonstrates fork
 *
 * Bernhard Rabe
 *
 * 03.11.2004
 */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>

int main(int argc,char *argv[])
{
    pid_t pid1;
    int status;
    
    pid1=fork();
    
    if(pid1<0)
    { 
        perror("Fehler bei fork\n"); 
        exit(1); 
    }

    if(pid1==0)
    { 
      printf("I'm the child: %d of %d\n",getpid(),getppid());
      exit(42);
    }
        
    printf("I'm the parent: %d of %d\n",getpid(),pid1);
    
    if (waitpid(pid1, &status, 0) < 0)
    {
	perror("waitpid hat nicht funktioniert");
	exit(1);
    }

    if (WIFEXITED(status))
    {
        printf ("Exit Status %d\n", WEXITSTATUS(status));
    }
    else
    {
	printf ("Prozess wurde nicht normal beendet\n");
    }
    return 23;
}
