/*
 * thread.c
 * POSIX Threads, detached/joinable mode, see makefile
 * only minimal error handling
 *
 * Bernhard Rabe
 * 22.11.2004
 *
 */

#include <windows.h>
#include <stdio.h>

static void ErrorExit(const char * msg, DWORD errcode)
{
    LPVOID *errmsg;
    
    if (!FormatMessage( 
        FORMAT_MESSAGE_ALLOCATE_BUFFER | 
        FORMAT_MESSAGE_FROM_SYSTEM | 
        FORMAT_MESSAGE_IGNORE_INSERTS,
        NULL,
        errcode,
        MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
        (LPTSTR) &errmsg,
        0,
        NULL )
    )
    {
        fprintf(stderr,"FormatMessage\n");
        exit(2);
    }

    fprintf(stderr, "Fehler: %s:%s\n", msg, errmsg);
    LocalFree(errmsg);
    exit(1);
}


DWORD WINAPI ThreadFunc(LPVOID data)
{
    int retval=0; 
    int val=*(int*)data;
    printf("%d\n",val);
    val=43;
    return val;
}

int main(int argc, char* argv[])
{
	HANDLE hThread;
    DWORD ret;
	int a=42,*b,c;
    
    
    hThread=CreateThread(NULL,0,ThreadFunc,&a,0,NULL);
	if(NULL==hThread)
	{
		ErrorExit("CreateThread",GetLastError());
	}

    if(WAIT_FAILED==WaitForSingleObject(hThread,INFINITE))
    {
	   ErrorExit("WaitForSingleObject",GetLastError());
        
	}   
    if(!GetExitCodeThread(hThread,&ret))
    {
        ErrorExit("GetExitCode",GetLastError());
        
    }
    if(!CloseHandle(hThread))
    {
        ErrorExit("CloseHandle",GetLastError());
    }
    printf("%d\n",ret);
	return 0;
}
